<?php
class dbXML 
	{
	/****************************************************************************************
	 * XML Database Object Class															*
	 * available methods																	*
	 *																						*
	 * constructor: sets up the object variables used to connect.							*
	 * add: Adds row to the db table.  xmlString describes the row in an xml document 		*
	 *		formatted like below.															*
	 * 		<root>																			*
	 *			<newdata>																	*
	 *				<column1>value1</column1>												*
	 *				<column2>value2</column2>												*
	 *				.																		*
	 *				.																		*
	 *				<columnN>valueN</columnN>												*
	 *			</newdata>																	*
	 *		</root>																			*
	 * getdata_xml: gets data from query specified and returns and xml string with the		* 
	 *				answer like below														*
	 *		<root>																			*
	 *			<row>																		*
	 *				<column1>value1</column1>												*
	 *				.																		*
	 *				<columnN>valueN</columnN>												*
	 *			</row>																		*
	 *			<row>																		*
	 *				<column1>value1</column1>												*
	 *				.																		*
	 *				.																		*
	 *				<columnN>valueN</columnN>												*
	 *			</row>																		*
	 *			.																			*
	 *		</root>																			*
	 * delete: deletes data using the query specified.										*
	 * update: updates the database table with the xmlString describing the criteria and	*
	 *		   newdata to update.															*
	 * 		<root>																			*
	 *			<criteria>																	*
	 *				<column>value</column>													*
	 *			</criteria>																	*
	 *			<newdata>																	*
	 *				<column1>value1</column1>												*
	 *				<column2>value2</column2>												*
	 *				.																		*
	 *				.																		*
	 *				<columnN>valueN</columnN>												*
	 *			</newdata>																	*
	 *		</root>																			*
	 ****************************************************************************************/
	
	var $db_name;	// the name of the database
	var $db_user;	// the username to access the database
	var $db_pass;	// the password to access the database
	
	function dbXML($db_name,$db_user,$db_pass) 
		{
		$this->db_name = $db_name;
		$this->db_user = $db_user;
		$this->db_pass = $db_pass;
		}
		
	function add($db_table,$xmlString,&$dberror) 
		{
		$xml = simplexml_load_string($xmlString);
		$newdata = $xml->newdata->children();

        $link = mysql_pconnect("localhost",$this->db_user,$this->db_pass);
		
        if(!$link) 
			{
			$dberror = "Couldn't connect to $db_name database server"; 
			return false; 
			}

        if (!mysql_select_db($this->db_name,$link)) 
			{
			$dberror = mysql_error(); 
			return false; 
			}
		
        $query = "INSERT INTO $db_table(";
		$first=true;
		foreach($newdata as $column=>$value)
			{
			if($first==true) $first=false;
			else $query .= ", ";
			$query .= $column;
			}
		$query .= ") values(";
		$first=true;
		foreach($newdata as $column=>$value)
			{
			if($first==true) $first=false;
			else $query .= ",";
			$query .= "'$value'";
			}
		$query .= ")";
		
        if(!mysql_query($query,$link)) 
			{
			$dberror = mysql_error(); 
			return false; 
			}

		mysql_close($link);
        return true;
		}
		
	function query($string,&$dberror)
		{
		$link = mysql_pconnect("localhost",$this->db_user,$this->db_pass);
    if(!$link) 
			{
			$dberror = "Couldn't connect to $db_name database server"; 
			return false; 
			}
    if (!mysql_select_db($this->db_name,$link))
			{
			$dberror = mysql_error(); 
			return false;
			}
    $result = mysql_query($string);
		mysql_close($link);
		return mysql_fetch_assoc($result);
		}
		
	function getdata_xml($query, &$dberror) 
		{
        $link = mysql_pconnect("localhost",$this->db_user,$this->db_pass);
        if(!$link) 
			{
			$dberror = "Couldn't connect to $db_name database server"; 
			return false;
			}
        if (!mysql_select_db($this->db_name,$link))
			{
			$dberror = mysql_error(); 
			return false;
			}
        $result = mysql_query($query);
		// create a new XML document
		$doc = new DomDocument('1.0');
		// create root node
		$root = $doc->createElement('root');
		$root = $doc->appendChild($root);
		while($row=mysql_fetch_assoc($result))
			{
			$occ = $doc->createElement('row');
 			$occ = $root->appendChild($occ);
			// add a child node for each field
  			foreach ($row as $fieldname => $fieldvalue) 
				{
				//convert the avg(value) into avg_value
				$fieldname = str_replace("(","_",$fieldname);
				$fieldname =  rtrim($fieldname,")");
				
				$child = $doc->createElement(addslashes($fieldname));
    			$child = $occ->appendChild($child);
				$value = $doc->createTextNode(addslashes($fieldvalue));
    			$value = $child->appendChild($value);
				}
			}
		// get completed xml document
		$xml_string = $doc->saveXML();
		mysql_close($link);
		return $xml_string;
		}

	function delete($query,&$dberror) 
		{
        $link = mysql_pconnect("localhost",$this->db_user,$this->db_pass);
        if(!$link) 
			{
			$dberror = "Couldn't connect to $db_name database server"; 
			return false; 
			}
        if (!mysql_select_db($this->db_name,$link)) 
			{
			$dberror = mysql_error(); 
			return false; 
			}
        if(!mysql_query($query,$link)) 
			{
			$dberror = mysql_error(); 
			return false; 
			}
		mysql_close($link);
        return true;
		}

	function update($db_table,$xmlString,&$dberror) 
		{
		$xml = simplexml_load_string($xmlString);
		$criteria = $xml->criteria->children();
		$newdata = $xml->newdata->children();
	
        $link = mysql_pconnect("localhost",$this->db_user,$this->db_pass);	
        if(!$link) 
			{
			$dberror = "Couldn't connect to $db_name database server"; 
			return false; 
			}
        if (!mysql_select_db($this->db_name,$link)) 
			{
			$dberror = mysql_error(); 
			return false; 
			}
        $query = "UPDATE $db_table SET ";
		$first=true;
		foreach($newdata as $feild=>$value)
			{
			if($first==true) $first=false;
			else $query .= ",";
			if($value==NULL) $query .= "$feild=NULL";
			else $query .= "$feild='$value'";
			}
		if($extra_arguments!="") $query .= ", $extra_arguments";

		$query .= " WHERE ";
		$first=true;
		foreach($criteria as $feild=>$value)
			{
			if($first==true) $first=false;
			else $query .= " AND ";
			$query .= "$feild='$value'";
			}
		
        if(!mysql_query($query,$link)) 
			{
			$dberror = mysql_error(); 
			return false; 
			}

		mysql_close($link);
        return true;
		}

}
?>